# These sources are disabled.
set dontsource {
  scripts/not_in_use.conf
}

# Now only source the ones that exist..
set sourced [set sourceerror [set sourcemissing {}]]
if {![info exists source]} { set source {} }
if {![info exists dontsource]} { set dontsource {} }
foreach f "$source" {
   if {[file exists "$f"]} {
      if {[lsearch -glob "$dontsource" "$f"] == -1} {
         putlog "Attempting to source $f..."
         if {[catch { source "$f" } err]} {
            putlog "ERROR LOADING $f: $err"
            lappend sourceerror "$f"
         } else {
            lappend sourced "$f"
         }
      } else {
         putlog "NOTICE: Skipping: $f (it's in the dontsource list.)"
      }
   } else {
      if {"$f" != {}} {
         putlog "WARNING: Missing: $f"
         lappend sourcemissing "$f"
      }
   }
}
unset source dontsource f

