#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include "../include/objects.h"

main (int argc, char **argv) {
 unsigned long	*fsize;
 unsigned long	*uspeed;
 unsigned long	*startsec;
 unsigned long	*startusec;
 unsigned long	*crc;
 unsigned char  buf[49 + 5 * sizeof(long)];
 char		*status;
 char		*fname;
 char		*p_buf;
 char		*uname;
 char		*ugroup;
 int		len;
 int		files = 0;
 FILE		*file;

 if ( argc != 2 ) {
	printf("Usage: %s <racedata file>\n", argv[0]);
	return 0;
	}

 if ( (file = fopen(argv[1], "r")) == NULL ) {
	printf("File does not exist or could not be opened\n");
        return 0;
        }

 printf("|-[Racedata lister for project-zs]\n");
 printf("|\n");

 while ( fread(&len, sizeof(int), 1, file) == 1 ) {
	fname = malloc(len);
	fread(fname, 1, len, file);
	if ( fread(buf, 1, sizeof(buf), file) != sizeof(buf) ) {
		printf("|-[CORRUPTED]\n");
		return 0;
		}
	files++;

	p_buf = buf + 1;
	crc = (long *)p_buf;		p_buf += sizeof(long);
	uname = p_buf;			p_buf += 24;
        ugroup = p_buf;			p_buf += 24;
	fsize = (long *)p_buf;		p_buf += sizeof(long);
	uspeed = (long *)p_buf;		p_buf += sizeof(long);
	startsec = (long *)&p_buf;	p_buf += sizeof(long);
	startusec = (long *)&p_buf;

	switch ( *buf ) {
		case F_NOTCHECKED:
			status = "Not checked";
			break;
                case F_CHECKED:
			status = "OK";
			break;
                case F_BAD:
			status = "BAD";
			break;
		case F_DELETED:
			status = "Deleted";
			break;
		}

	printf("|-[File #%i]\n", files);
	printf("| Filename: %s - Status: %s - CRC-32: %08X - Filesize: %u\n", fname, status, *crc, *fsize);
	printf("| User    : %s - Group: %s - Speed: %0.1fKb/s\n", uname, ugroup, *fsize * 1024. / *uspeed);

	free(fname);
	}
 printf("|-[EOF]\n");
 fclose(file);
}
